diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java
index 9de269fac..08887a0c9 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java
@@ -23,7 +23,7 @@ import net.minecraft.client.gui.guidebook.search.GuidebookPageSearch;
 import net.minecraft.client.option.enums.DescriptionPromptEnum;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.core.achievement.Achievements;
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCrafting;
@@ -37,12 +37,9 @@ import net.minecraft.core.data.registry.recipe.entry.RecipeEntryMapDuplication;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryRepairable;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryScrap;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryUndyeing;
-import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.client.gui.guidebook.SlotGuidebook;
-import org.lwjgl.input.Keyboard;
-import org.lwjgl.opengl.GL11;
 
 import java.util.ArrayList;
 import java.util.HashMap;
@@ -50,11 +47,11 @@ import java.util.List;
 import java.util.Map;
 
 public class RecipePageCrafting
-    extends RecipePage<RecipeEntryCrafting<?,?>> {
+    extends RecipePage<RecipeEntryCrafting<?, ?>> {
     public static final int RECIPES_PER_PAGE = 3;
 
     public List<SlotGuidebook> slots;
-    public Map<RecipeEntryCrafting<?,?>,List<SlotGuidebook>> map;
+    public Map<RecipeEntryCrafting<?, ?>, List<SlotGuidebook>> map;
 
     public static Map<Class<? extends RecipeEntryCrafting<?, ?>>, RecipeDisplayAdapter<?>> recipeToDisplayAdapterMap = new HashMap<>();
 
@@ -76,22 +73,22 @@ public class RecipePageCrafting
     private static final Minecraft mc = Minecraft.getMinecraft();
     private static long ticks = 0;
 
-    public RecipePageCrafting(GuidebookSection section, List<RecipeEntryCrafting<?,?>> recipes) {
+    public RecipePageCrafting(GuidebookSection section, List<RecipeEntryCrafting<?, ?>> recipes) {
         super(section);
         this.recipes = recipes;
         this.slots = new ArrayList<>();
         this.map = new HashMap<>();
-        tooltipElement = new TooltipElement(mc);
-        itemElement = new ItemElement(mc);
+        this.tooltipElement = new TooltipElement(mc);
+        this.itemElement = new ItemElement(mc);
         int recipeAmount = 0;
         int xOffset = 32;
         int yOffset = 12;
-        for (RecipeEntryCrafting<?,?> recipe : recipes) {
+        for (RecipeEntryCrafting<?, ?> recipe : recipes) {
             if (recipeToDisplayAdapterMap.containsKey(recipe.getClass())) {
                 RecipeDisplayAdapter adapter = recipeToDisplayAdapterMap.get(recipe.getClass());
                 List<SlotGuidebook> recipeSlots = adapter.getSlots(recipe, recipeAmount, xOffset, yOffset);
-                map.put(recipe,recipeSlots);
-                slots.addAll(recipeSlots);
+                this.map.put(recipe, recipeSlots);
+                this.slots.addAll(recipeSlots);
                 yOffset += 10;
                 recipeAmount++;
             }
@@ -102,10 +99,10 @@ public class RecipePageCrafting
     @Override
     public void onTick() {
         ticks++;
-        for (SlotGuidebook slot : slots) {
-            if(ticks > 20) {
+        for (SlotGuidebook slot : this.slots) {
+            if (ticks > 20) {
                 slot.showRandomItem();
-                if(slots.get(slots.size()-1) == slot){
+                if (this.slots.get(this.slots.size() - 1) == slot) {
                     ticks = 0;
                 }
             }
@@ -114,36 +111,35 @@ public class RecipePageCrafting
 
     @Override
     protected void renderForeground(TextureManager re, FontRenderer sr, int x, int y, int mouseX, int mouseY, float partialTicks) {
-        if(recipes.isEmpty()){
-            drawStringCenteredNoShadow(sr, I18n.getInstance().translateKey("guidebook.section.search.error.no_recipes"), x+width/2,y+height/2,0xFF808080);
+        if (this.recipes.isEmpty()) {
+            drawStringCenteredNoShadow(sr, I18n.getInstance().translateKey("guidebook.section.search.error.no_recipes"), x + this.width / 2, y + this.height / 2, 0xFF808080);
         }
         SlotGuidebook mouseOverSlot = null;
-        for (SlotGuidebook slot : slots) {
-            if(slot.item != null){
-                if(!slot.isOutput) slot.item.stackSize = 1;
+        for (SlotGuidebook slot : this.slots) {
+            if (slot.item != null) {
+                if (!slot.isOutput) slot.item.stackSize = 1;
             }
-            drawSlot(x+slot.x -1,y+slot.y -1,0xFFFFFFFF);
-            if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
-            itemElement.render(slot.getItemStack(),x+slot.x,y+slot.y,mouseOverSlot == slot,slot);
+            drawSlot(x + slot.x - 1, y + slot.y - 1, 0xFFFFFFFF);
+            if (getIsMouseOverSlot(slot, x, y, mouseX, mouseY)) mouseOverSlot = slot;
+            this.itemElement.render(slot.getItemStack(), x + slot.x, y + slot.y, mouseOverSlot == slot, slot);
         }
     }
 
-    public boolean getIsMouseOverSlot(final Slot slot, int x, int y, int mouseX, int mouseY)
-    {
-        return mouseX >= x+slot.x - 1 && mouseX < x+slot.x + 16 + 1 && mouseY >= y+slot.y - 1 && mouseY < y+slot.y + 16 + 1;
+    public boolean getIsMouseOverSlot(final Slot slot, int x, int y, int mouseX, int mouseY) {
+        return mouseX >= x + slot.x - 1 && mouseX < x + slot.x + 16 + 1 && mouseY >= y + slot.y - 1 && mouseY < y + slot.y + 16 + 1;
     }
 
     @Override
     public boolean keyTyped(char c, int key, int x, int y, int mouseX, int mouseY) {
         super.keyTyped(c, key, x, y, mouseX, mouseY);
-        if(mc.gameSettings.keyShowRecipe.isKeyboardKey(key)){
-            SlotGuidebook hoveringSlot= null;
-            for (SlotGuidebook slot : slots) {
-                if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) hoveringSlot = slot;
+        if (mc.gameSettings.keyShowRecipe.isKeyboardKey(key)) {
+            SlotGuidebook hoveringSlot = null;
+            for (SlotGuidebook slot : this.slots) {
+                if (getIsMouseOverSlot(slot, x, y, mouseX, mouseY)) hoveringSlot = slot;
             }
-            if(hoveringSlot != null){
-                if(hoveringSlot.hasItem()){
-                    String query = "r:"+hoveringSlot.getItemStack().getDisplayName()+"!";
+            if (hoveringSlot != null) {
+                if (hoveringSlot.hasItem()) {
+                    String query = "r:" + hoveringSlot.getItemStack().getDisplayName() + "!";
                     GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
                     GuidebookPageSearch.searchField.setText(query);
                     ScreenGuidebook.getPageManager().updatePages();
@@ -152,11 +148,11 @@ public class RecipePageCrafting
                 }
             }
         } else if (mc.gameSettings.keyShowUsage.isKeyboardKey(key)) {
-            SlotGuidebook hoveringSlot= null;
-            for (SlotGuidebook slot : slots) {
-                if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) hoveringSlot = slot;
+            SlotGuidebook hoveringSlot = null;
+            for (SlotGuidebook slot : this.slots) {
+                if (getIsMouseOverSlot(slot, x, y, mouseX, mouseY)) hoveringSlot = slot;
             }
-            if(hoveringSlot != null) {
+            if (hoveringSlot != null) {
                 if (hoveringSlot.hasItem()) {
                     String query = "u:" + hoveringSlot.getItemStack().getDisplayName() + "!";
                     GuidebookPageManager.searchQuery = SearchQuery.resolve(query);
@@ -180,10 +176,10 @@ public class RecipePageCrafting
     protected void renderBackground(TextureManager re, int x, int y) {
         super.renderBackground(re, x, y);
         re.bindTexture(re.loadTexture("/assets/minecraft/textures/gui/container/guidebook/guidebook.png"));
-        for (int i = 1; i <= recipes.size(); i++) {
-            RecipeEntryCrafting<?, ?> recipe = recipes.get(i-1);
-            List<SlotGuidebook> list = map.get(recipe);
-            drawTexturedModalRect(x + list.get(list.size()-1).x - 25, y +  list.get(list.size()-1).y, 234, 0, 22, 15);
+        for (int i = 1; i <= this.recipes.size(); i++) {
+            RecipeEntryCrafting<?, ?> recipe = this.recipes.get(i - 1);
+            List<SlotGuidebook> list = this.map.get(recipe);
+            drawTexturedModalRect(x + list.get(list.size() - 1).x - 25, y + list.get(list.size() - 1).y, 234, 0, 22, 15);
         }
     }
 
@@ -191,16 +187,14 @@ public class RecipePageCrafting
     protected void renderOverlay(TextureManager re, FontRenderer sr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         super.renderOverlay(re, sr, x, y, mouseX, mouseY, partialTicks);
         SlotGuidebook mouseOverSlot = null;
-        for (SlotGuidebook slot : slots) {
-            if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
-            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-            if (mouseOverSlot != null && mouseOverSlot.hasItem())
-            {
+        for (SlotGuidebook slot : this.slots) {
+            if (getIsMouseOverSlot(slot, x, y, mouseX, mouseY)) mouseOverSlot = slot;
+            GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+            if (mouseOverSlot != null && mouseOverSlot.hasItem()) {
                 boolean showDescription = DescriptionPromptEnum.showDescription(mc);
-                String str = tooltipElement.getTooltipText(mouseOverSlot.getItemStack(), showDescription, mouseOverSlot);
-                if(!str.isEmpty())
-                {
-                    tooltipElement.render(str, mouseX, mouseY, 8, -8);
+                String str = this.tooltipElement.getTooltipText(mouseOverSlot.getItemStack(), showDescription, mouseOverSlot);
+                if (!str.isEmpty()) {
+                    this.tooltipElement.render(str, mouseX, mouseY, 8, -8);
                 }
             }
         }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
index 0aeff3f7c..885d0090c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/GuidebookPageMob.java
@@ -9,7 +9,9 @@ import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.client.option.enums.DescriptionPromptEnum;
 import net.minecraft.client.render.*;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.achievement.stat.StatList;
@@ -22,10 +24,6 @@ import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.client.gui.guidebook.SlotGuidebook;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.world.World;
-import org.lwjgl.input.Keyboard;
-import org.lwjgl.opengl.GL11;
-import org.lwjgl.opengl.GL12;
 import org.slf4j.Logger;
 
 import java.util.*;
@@ -44,7 +42,6 @@ public class GuidebookPageMob
     private boolean discovered;
 
 
-
     public GuidebookPageMob(GuidebookSection section, Class<? extends Mob> mobClass, MobInfoRegistry.MobInfo mobInfo) {
         super(section);
 
@@ -60,18 +57,18 @@ public class GuidebookPageMob
         if (example != null) example.setSkinVariant(0);
 
         if (mobInfo.getDrops() != null && mobInfo.getDrops().length > 0) {
-            slots = new ArrayList<>();
-            dropSlotMap = new HashMap<>();
+            this.slots = new ArrayList<>();
+            this.dropSlotMap = new HashMap<>();
             for (int i = 0; i < mobInfo.getDrops().length; i++) {
                 MobInfoRegistry.MobDrop drop = mobInfo.getDrops()[i];
                 SlotGuidebook slot = new SlotGuidebook(i, 0, 0, new RecipeSymbol(drop.getStack()), false, null);
-                slots.add(slot);
-                dropSlotMap.put(drop, slot);
+                this.slots.add(slot);
+                this.dropSlotMap.put(drop, slot);
             }
         }
 
         EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForClass(mobClass);
-        discovered = mc.statsCounter.readStat(StatList.mobEncounterStats.get(entry != null ? entry.namespaceID : null)) > 0;
+        this.discovered = mc.statsCounter.readStat(StatList.mobEncounterStats.get(entry != null ? entry.namespaceID : null)) > 0;
     }
 
     private static String[] createDescLines(FontRenderer sr, String languageKey) {
@@ -103,72 +100,73 @@ public class GuidebookPageMob
 
     @Override
     protected void renderBackground(TextureManager re, int x, int y) {
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         re.bindTexture(re.loadTexture("/assets/minecraft/textures/gui/container/guidebook/mob.png"));
         drawTexturedModalRect(x, y, 0, 0, 158, 220);
     }
 
     @Override
     protected void renderForeground(TextureManager re, FontRenderer sr, int x, int y, int mouseX, int mouseY, float partialTicks) {
-        EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForClass(mobClass);
-        discovered = mc.statsCounter.readStat(StatList.mobEncounterStats.get(entry != null ? entry.namespaceID : null)) > 0;
-        if (mc.thePlayer.getGamemode() == Gamemode.creative || !mc.gameSettings.hideUndiscoveredItems.value) discovered = true;
+        EntityDispatcher.EntityDispatcherEntry<?> entry = EntityDispatcher.getInstance().entryForClass(this.mobClass);
+        this.discovered = mc.statsCounter.readStat(StatList.mobEncounterStats.get(entry != null ? entry.namespaceID : null)) > 0;
+        if (mc.thePlayer.getGamemode() == Gamemode.creative || !mc.gameSettings.hideUndiscoveredItems.value)
+            this.discovered = true;
 
         Lighting.disable();
-        if(mobInfo != null) {
+        if (this.mobInfo != null) {
             I18n i18n = I18n.getInstance();
 
             String[] lines;
-            if (!discovered) {
+            if (!this.discovered) {
                 lines = createDescLines(sr, "guidebook.section.mob.undiscovered");
             } else {
-                lines = createDescLines(sr, mobInfo.getDescriptionTranslationKey());
+                lines = createDescLines(sr, this.mobInfo.getDescriptionTranslationKey());
             }
 
             // Display name
             int yOffset = y + 8;
-            String name = i18n.translateKey(mobInfo.getNameTranslationKey());
-            if (!discovered) {
+            String name = i18n.translateKey(this.mobInfo.getNameTranslationKey());
+            if (!this.discovered) {
                 name = new String(new char[name.length()]).replace("\0", "?");
             }
             drawStringNoShadow(sr, name, x + 66, y + 8, 0x000000);
 
-            if (discovered) {
+            if (this.discovered) {
                 // Display health
-                if (mobInfo.getHealth() > 0) {
-                    if(mobInfo.getHealth() > 40){
+                if (this.mobInfo.getHealth() > 0) {
+                    if (this.mobInfo.getHealth() > 40) {
                         yOffset += 12;
                         drawStringNoShadow(sr, i18n.translateKey("guidebook.section.mob.health"), x + 66, yOffset, 0x505050);
                         yOffset += 6;
-                        GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
+                        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
                         yOffset += 4;
                         drawGuiIcon(x + 66, yOffset, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/container"));
                         drawGuiIcon(x + 66, yOffset, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/full"));
-                        drawStringNoShadow(sr, "x "+mobInfo.getHealth()/2, x + 66 + 12, yOffset, 0x505050);
+                        drawStringNoShadow(sr, "x " + this.mobInfo.getHealth() / 2, x + 66 + 12, yOffset, 0x505050);
 
                     } else {
                         yOffset += 12;
                         drawStringNoShadow(sr, i18n.translateKey("guidebook.section.mob.health"), x + 66, yOffset, 0x505050);
                         yOffset += 6;
-                        GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-                        for (int i = 0; i < mobInfo.getHealth() / 2; i++) {
+                        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
+                        for (int i = 0; i < this.mobInfo.getHealth() / 2; i++) {
                             if (i % 10 == 0) {
                                 yOffset += 4;
                             }
                             drawGuiIcon(x + 66 + (i % 10) * 8, yOffset, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/container"));
                             drawGuiIcon(x + 66 + (i % 10) * 8, yOffset, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/full"));
                         }
-                        if (mobInfo.getHealth() % 2 == 1) {
-                            drawGuiIcon(x + 66 + ((mobInfo.getHealth() / 2) % 10) * 8, yOffset, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/container"));
-                            drawGuiIcon(x + 66 + ((mobInfo.getHealth() / 2) % 10) * 8, yOffset, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/half"));
+                        if (this.mobInfo.getHealth() % 2 == 1) {
+                            drawGuiIcon(x + 66 + ((this.mobInfo.getHealth() / 2) % 10) * 8, yOffset, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/container"));
+                            drawGuiIcon(x + 66 + ((this.mobInfo.getHealth() / 2) % 10) * 8, yOffset, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/heart/half"));
                         }
                     }
                 }
 
                 // Display score
-                if (mobInfo.getScore() > 0) {
+                if (this.mobInfo.getScore() > 0) {
                     yOffset += 11;
-                    drawStringNoShadow(sr, i18n.translateKeyAndFormat("guidebook.section.mob.score", mobInfo.getScore()), x + 66, yOffset, 0x505050);
+                    drawStringNoShadow(sr, i18n.translateKeyAndFormat("guidebook.section.mob.score", this.mobInfo.getScore()), x + 66, yOffset, 0x505050);
                 }
             }
 
@@ -179,23 +177,23 @@ public class GuidebookPageMob
                 yOffset += 10;
             }
 
-            if (discovered) {
+            if (this.discovered) {
                 // Display drops
-                if (mobInfo.getDrops() != null && mobInfo.getDrops().length > 0) {
+                if (this.mobInfo.getDrops() != null && this.mobInfo.getDrops().length > 0) {
                     yOffset += 4;
                     drawStringNoShadow(sr, i18n.translateKey("guidebook.section.mob.drops"), x + 8, yOffset, 0x000000);
                     yOffset += 12;
-                    for (int i = 0; i < mobInfo.getDrops().length; i++) {
-                        SlotGuidebook slot = slots.get(i);
+                    for (int i = 0; i < this.mobInfo.getDrops().length; i++) {
+                        SlotGuidebook slot = this.slots.get(i);
                         slot.x = 7 + (i % 7) * 21;
                         slot.y = (yOffset - y) + (i / 7) * 20;
-                        MobInfoRegistry.MobDrop drop = mobInfo.getDrops()[i];
+                        MobInfoRegistry.MobDrop drop = this.mobInfo.getDrops()[i];
                         boolean mouseOver = getIsMouseOverSlot(slot, x, y, mouseX, mouseY);
                         drawSlot(x + 7 + (i % 7) * 21, yOffset + (i / 7) * 20, 0xFFFFFFFF);
-                        GL11.glPushMatrix();
-                        GL11.glTranslatef(0, 0, 50f);
+                        GLRenderer.pushFrame();
+                        GLRenderer.modelM4f().translate(0, 0, 50f);
                         itemElement.render(slot.getItemStack(), x + 8 + (i % 7) * 21, yOffset + 1 + (i / 7) * 20, mouseOver, slot);
-                        GL11.glPopMatrix();
+                        GLRenderer.popFrame();
                         if (slot.getIsDiscovered(mc.thePlayer)) {
                             String amountString = drop.getMinAmount() == drop.getMaxAmount() ? String.valueOf(drop.getMinAmount()) : drop.getMinAmount() + "-" + drop.getMaxAmount();
                             int width = MathHelper.ceil(sr.stringWidthDouble(amountString));
@@ -205,7 +203,7 @@ public class GuidebookPageMob
                 }
             }
         } else {
-            drawStringCenteredNoShadow(sr,"No results :(" ,x+width/2,y+height/2,0xFF808080);
+            drawStringCenteredNoShadow(sr, "No results :(", x + this.width / 2, y + this.height / 2, 0xFF808080);
         }
 
         renderMob(x, y, mouseX, mouseY, partialTicks);
@@ -215,14 +213,14 @@ public class GuidebookPageMob
     public void onMouseDown(int x, int y, int mouseX, int mouseY, int button) {
         super.onMouseDown(x, y, mouseX, mouseY, button);
 
-        if (example == null) {
+        if (this.example == null) {
             return;
         }
 
-        if (discovered) {
+        if (this.discovered) {
             if (mouseX > x + 9 && mouseX < x + 9 + 52 && mouseY > y + 9 && mouseY < y + 9 + 70) {
-                String livingSound = example.getLivingSound();
-                if (example.cycleVariant() && livingSound != null) {
+                String livingSound = this.example.getLivingSound();
+                if (this.example.cycleVariant() && livingSound != null) {
                     Minecraft mc = Minecraft.getMinecraft();
                     Random random = new Random();
                     mc.currentWorld.playSoundAtEntity(null, mc.thePlayer, livingSound, 0.25f, (random.nextFloat() - random.nextFloat()) * 0.2F + 1.0F);
@@ -233,42 +231,44 @@ public class GuidebookPageMob
     }
 
     private void renderMob(int x, int y, int mouseX, int mouseY, float partialTicks) {
-        if (example == null) {
+        if (this.example == null) {
             return;
         }
-        if (!discovered) return;
+        if (!this.discovered) return;
 
         float heightFactor = 50f / 1.8f;
 
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
 
         Scissor.enable(x + 9, y + 9, 52, 70);
 
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        GL11.glEnable(GL11.GL_COLOR_MATERIAL);
-        GL11.glEnable(GL11.GL_DEPTH_TEST);
-        GL11.glPushMatrix();
-        GL11.glTranslatef(x + 34, y + 44 + 32, 50F);
-        float f1 = 30F;
-        GL11.glScalef(-f1, f1, f1);
-        GL11.glRotatef(180F, 0.0F, 0.0F, 1.0F);
-        float f5 = (float)(x + 34) - mouseX;
-        float f6 = (float)(y + 44 + 32) - (heightFactor * example.bbHeight) - mouseY;
-        GL11.glRotatef(135F, 0.0F, 1.0F, 0.0F);
+//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+//        GL11.glEnable(GL11.GL_COLOR_MATERIAL);
+        GLRenderer.enableState(State.DEPTH_TEST);
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.WORLD);
+        GLRenderer.modelM4f().translate(x + 34, y + 44 + 32, 50F);
+        float scale = 30F;
+        GLRenderer.modelM4f().scale(-scale, scale, scale);
+        GLRenderer.modelM4f().rotateZ(org.joml.Math.toRadians(180F));
+        float f5 = (float) (x + 34) - mouseX;
+        float f6 = (float) (y + 44 + 32) - (heightFactor * this.example.bbHeight) - mouseY;
+        GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(135F));
         Lighting.enableLight();
-        GL11.glRotatef(-135F, 0.0F, 1.0F, 0.0F);
-        GL11.glRotatef(-(float)Math.atan(f6 / 40F) * 20F, 1.0F, 0.0F, 0.0F);
-        example.yBodyRot = (float)Math.atan(f5 / 40F) * 20F;
-        example.yRot = (float)Math.atan(f5 / 40F) * 40F;
-        example.xRot = -(float)Math.atan(f6 / 40F) * 20F;
-        example.entityBrightness = 1.0F;
-        GL11.glTranslatef(0.0F, example.heightOffset, 0.0F);
-        EntityRenderDispatcher.instance.viewLerpYaw = 180F;
-        EntityRenderDispatcher.instance.renderEntityPreviewWithPosYaw(Tessellator.instance, example, 0.0D, 0.0D, 0.0D, 0.0F, 1.0F);
-        GL11.glPopMatrix();
+        GLRenderer.modelM4f().rotateY(org.joml.Math.toRadians(-135F));
+        GLRenderer.modelM4f().rotateX(org.joml.Math.toRadians(-(float) Math.atan(f6 / 40F) * 20F));
+        this.example.yBodyRot = (float) Math.atan(f5 / 40F) * 20F;
+        this.example.yRot = (float) Math.atan(f5 / 40F) * 40F;
+        this.example.xRot = -(float) Math.atan(f6 / 40F) * 20F;
+        this.example.entityBrightness = 1.0F;
+        GLRenderer.modelM4f().translate(0.0F, this.example.heightOffset, 0.0F);
+        EntityRendererDispatcher.instance.viewLerpYaw = 180F;
+        GLRenderer.globalGetNormalTransformMatrix().scale(1, -1, 1);
+        EntityRendererDispatcher.instance.renderEntityPreviewWithPosYaw(GLRenderer.getTessellator(), this.example, 0.0D, 0.0D, 0.0D, 0.0F, 1.0F);
+        GLRenderer.popFrame();
         Lighting.disable();
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
-        GL11.glDisable(GL11.GL_DEPTH_TEST);
+//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+        GLRenderer.disableState(State.DEPTH_TEST);
 
         Scissor.disable();
     }
@@ -276,17 +276,15 @@ public class GuidebookPageMob
     @Override
     protected void renderOverlay(TextureManager re, FontRenderer sr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         super.renderOverlay(re, sr, x, y, mouseX, mouseY, partialTicks);
-        if (slots == null) return;
+        if (this.slots == null) return;
         SlotGuidebook mouseOverSlot = null;
-        for (SlotGuidebook slot : slots) {
-            if(getIsMouseOverSlot(slot,x,y,mouseX,mouseY)) mouseOverSlot = slot;
-            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-            if (mouseOverSlot != null && mouseOverSlot.hasItem())
-            {
+        for (SlotGuidebook slot : this.slots) {
+            if (getIsMouseOverSlot(slot, x, y, mouseX, mouseY)) mouseOverSlot = slot;
+            GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+            if (mouseOverSlot != null && mouseOverSlot.hasItem()) {
                 boolean showDescription = DescriptionPromptEnum.showDescription(mc);
                 String str = tooltipElement.getTooltipText(mouseOverSlot.getItemStack(), showDescription, mouseOverSlot);
-                if(!str.isEmpty())
-                {
+                if (!str.isEmpty()) {
                     tooltipElement.render(str, mouseX, mouseY, 8, -8);
                 }
             }
@@ -294,9 +292,8 @@ public class GuidebookPageMob
 
     }
 
-    public boolean getIsMouseOverSlot(final Slot slot, int x, int y, int mouseX, int mouseY)
-    {
-        return mouseX >= x+slot.x - 1 && mouseX < x+slot.x + 16 + 1 && mouseY >= y+slot.y - 1 && mouseY < y+slot.y + 16 + 1;
+    public boolean getIsMouseOverSlot(final Slot slot, int x, int y, int mouseX, int mouseY) {
+        return mouseX >= x + slot.x - 1 && mouseX < x + slot.x + 16 + 1 && mouseY >= y + slot.y - 1 && mouseY < y + slot.y + 16 + 1;
     }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
index 5a3d58c88..d9e4ea1b1 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobInfoRegistry.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.gui.guidebook.mobs;
 
-import net.minecraft.client.render.EntityRenderDispatcher;
+import net.minecraft.client.render.EntityRendererDispatcher;
 import net.minecraft.client.render.entity.EntityRenderer;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
@@ -214,7 +214,7 @@ public abstract class MobInfoRegistry {
         }
 
         public EntityRenderer<?> getRenderer() {
-            return EntityRenderDispatcher.instance.getRenderer(entityClass);
+            return EntityRendererDispatcher.instance.getRenderer(entityClass);
         }
 
         public String getNameTranslationKey() {
